/* I was looking though old code, and the one is genius, if a do say so myself.
   I cleaned it up.
   -Neil

Multi-byte fields are LSB first
header: 6 bytes (one header per data stream)
	Signature: 3 bytes, 'GIF'
	Version: 3 bytes, '87a' or '89a'
logical screen descriptor (one per data stream, follow header)
	Logical screen width: 2 bytes
	Logical screen height: 2 bytes
	Packed Data: 1 byte
		Global colour table flag: 1 bit (global table follows?)
		Colour resolution - 1: 3 bits
		Sort flag: 1 bit (important colours first? 0 in 87a)
		Size of global colour table: 3 bits (size is 2^(x+1))
	Background colour: 1 byte
	Pixel aspect ratio: 1 byte (0 = ignore 0 in 87a)
global colour table: 3 * 2 ^ (size of table + 1) bytes if table flag
	RGB: 3 bytes
[
image descriptor: (one per image)
	Image separator: 1 byte 0x2C
	Image left position: 2 bytes
	Image top position: 2 bytes
	Image width: 2 bytes
	Image height: 2 bytes
	Packed data:
		Local colour table?: 1 bit
		Interlace?: 1 bit
		Sorted palette?: 1 bit
		Reserved = 0: 2 bits
		Local colour table size: 3 bits
local colour table: 3 * 2 ^ (size of table + 1) bytes if table flag
	RGB: 3 bytes
code size: 1 byte
repeated data sub-blocks: terminated by zero-size sub-block
	Size: 1 byte
	Data: Size bytes
]
trailer: (one per data stream)
	GIF trailer: 1 byte, 0x3B ';'
*/

#include <stdlib.h> /* getenv(), atoi() */
#include <stdio.h>  /* printf(), putchar(), fwrite() */
#include <string.h> /* strcmp() */

typedef struct tagCode Code;

struct tagCode {
	Code          *child;
	Code          *next;
	unsigned char suffix;
	unsigned long code;
	unsigned int  code_size;
};

static void print_gif(unsigned char parm);

int main(int argc, char **argv) {
	char *env;

	if(!(env = getenv("REQUEST_METHOD"))
	|| (strcmp(env, "get") && strcmp(env, "GET"))
	|| !(env = getenv("QUERY_STRING"))) {
		printf("Status: 400 Missing required argument.\n\n");
		return EXIT_FAILURE;
	}
	printf("Content-type: image/gif\n\n");
	/* may need to set STDOUT to binary mode to avoid line feed translation
	if your OS sucks (you know who you are!)
	if(setmode(stdout, O_BINARY) == -1) return 1; */
	print_gif(atoi(env));

	return EXIT_SUCCESS;
}

static void print_gif(unsigned char parm) {
	/* this is the gif binary output; mine, you could use whatever and paste it
	here from the hex editor, just make it 00-FF as it goes across the image */
	static unsigned char image_data[] = {
	0x08, 0xFE, 0x00, 0x5B, 0x38, 0x18, 0x80, 0xC0, 0x02, 0x8A, 0x18, 0x39,
	0x8A, 0x20, 0xA9, 0xB1, 0xA1, 0xC2, 0x05, 0x0C, 0x16, 0x24, 0x38, 0x60,
	0xD0, 0xE0, 0x41, 0x84, 0x09, 0x15, 0x34, 0x98, 0xE8, 0xC1, 0xA4, 0x09,
	0x13, 0x23, 0x3A, 0x5E, 0x98, 0xF8, 0xD0, 0x01, 0x04, 0x8B, 0x24, 0x56,
	0x9C, 0x10, 0x21, 0x72, 0x85, 0x4C, 0x19, 0x30, 0x54, 0x96, 0xF0, 0xA0,
	0x81, 0x83, 0xC7, 0x8E, 0x21, 0x59, 0xB4, 0x14, 0xD9, 0x81, 0xE3, 0xC6,
	0x0D, 0x1C, 0x39, 0x72, 0xE8, 0xD8, 0xD1, 0x83, 0x67, 0x8E, 0x1E, 0x3D,
	0x74, 0x00, 0xE5, 0x11, 0x44, 0x88, 0x10, 0x22, 0x47, 0x8E, 0x00, 0xE1,
	0xC1, 0xA3, 0xC7, 0x8F, 0x1F, 0x42, 0x9E, 0xB8, 0xC9, 0xA3, 0xA6, 0x4B,
	0x95, 0x27, 0x4B, 0x9A, 0x40, 0xB9, 0xD2, 0x65, 0xCC, 0x18, 0x2E, 0x5F,
	0x3B, 0x42, 0xB1, 0xD2, 0x45, 0x0C, 0x1A, 0x39, 0x7F, 0x18, 0x05, 0x22,
	0xB3, 0xA5, 0x0B, 0x98, 0x32, 0x79, 0x22, 0x59, 0x42, 0x14, 0x67, 0x4D,
	0x9B, 0x3C, 0x89, 0x1A, 0xED, 0x49, 0x43, 0x86, 0x4D, 0x20, 0x49, 0x96,
	0x3A, 0x95, 0x2A, 0x95, 0x09, 0x50, 0x1C, 0x37, 0x6E, 0xDE, 0xC0, 0x89,
	0x03, 0xE7, 0x8D, 0x65, 0x38, 0x74, 0xF2, 0x08, 0x7A, 0xE4, 0x89, 0x95,
	0x2A, 0x4A, 0x83, 0x0C, 0x85, 0x8A, 0xC5, 0x8A, 0xD4, 0xA9, 0x59, 0xB6,
	0x50, 0x71, 0x62, 0x65, 0xAB, 0x15, 0xAA, 0x55, 0xB2, 0x62, 0xB5, 0x5A,
	0xC5, 0x2A, 0x96, 0xAE, 0x61, 0xC6, 0x90, 0x25, 0x43, 0x76, 0x2C, 0x19,
	0xB3, 0x66, 0xCE, 0x9C, 0x3D, 0x73, 0x86, 0xCC, 0xD7, 0xAF, 0x65, 0xD2,
	0xA4, 0x2D, 0xFB, 0xB5, 0x8B, 0x17, 0xB1, 0x67, 0xD2, 0xA0, 0x45, 0xB3,
	0x96, 0x2D, 0x5B, 0x35, 0x64, 0xBD, 0x7A, 0x0D, 0x4B, 0xD6, 0xAC, 0xDA,
	0xB6, 0x66, 0xB1, 0x64, 0xFE, 0x39, 0xCB, 0x16, 0x2C, 0x15, 0xA8, 0x4F,
	0xA0, 0x42, 0x89, 0x2A, 0xC5, 0x8A, 0x56, 0x2E, 0x5C, 0xB4, 0x66, 0xAB,
	0x52, 0xC5, 0xEA, 0x95, 0x2D, 0x5D, 0xC2, 0xB2, 0xB5, 0x13, 0x38, 0x80,
	0xC0, 0x02, 0x08, 0x14, 0x78, 0xA0, 0x03, 0x10, 0x27, 0x50, 0x70, 0xD1,
	0x04, 0x12, 0x3C, 0xC0, 0xC0, 0x82, 0x0E, 0x3C, 0x20, 0x01, 0x05, 0x17,
	0x70, 0x80, 0x02, 0x11, 0x4D, 0x10, 0xB1, 0x43, 0x0D, 0x31, 0xA0, 0xE0,
	0x81, 0x06, 0x1C, 0x9C, 0x10, 0x84, 0x11, 0x31, 0xA8, 0x10, 0x03, 0x14,
	0x62, 0x8C, 0xA1, 0x85, 0x12, 0x3F, 0xDC, 0x20, 0x03, 0x0D, 0x37, 0xD4,
	0x90, 0x03, 0x14, 0x53, 0xFC, 0x80, 0x03, 0x0D, 0x31, 0xC8, 0x50, 0x03,
	0x0E, 0x40, 0xED, 0xC0, 0x83, 0x0E, 0x3E, 0xED, 0xB0, 0x43, 0x0E, 0x3D,
	0x62, 0x25, 0xC4, 0x10, 0x47, 0x20, 0x31, 0x84, 0x4D, 0x3C, 0xF8, 0xE0,
	0x03, 0x10, 0x4D, 0xAC, 0xF1, 0x46, 0x15, 0x4C, 0x24, 0x81, 0x44, 0x12,
	0x4A, 0x28, 0xC1, 0xC4, 0x58, 0x5E, 0x78, 0xE5, 0x44, 0x47, 0x4F, 0x44,
	0x31, 0x45, 0x15, 0x56, 0x68, 0x51, 0x46, 0x20, 0x7C, 0x7C, 0x51, 0x45,
	0x15, 0x59, 0x8C, 0xE1, 0x47, 0x24, 0x8A, 0xC8, 0x61, 0x06, 0x1A, 0x6E,
	0xD4, 0xF1, 0x47, 0x22, 0x7C, 0xA4, 0x31, 0x86, 0x1A, 0x7A, 0x0C, 0x02,
	0x48, 0x24, 0xA2, 0x84, 0xE2, 0x88, 0x1D, 0x6E, 0xB0, 0xB1, 0x86, 0x1A,
	0x6A, 0xAC, 0x31, 0x68, 0xA1, 0x6D, 0xC8, 0x71, 0x47, 0x1F, 0x88, 0x68,
	0xA2, 0xCA, 0x2A, 0x9B, 0x28, 0x92, 0x48, 0x27, 0xA8, 0x64, 0x72, 0x88,
	0x22, 0xA4, 0xC0, 0x02, 0xCA, 0x24, 0xA7, 0xA4, 0xF2, 0x48, 0x22, 0x8E,
	0x68, 0xA2, 0x89, 0x24, 0x8F, 0x48, 0xD2, 0xC9, 0x2B, 0xBE, 0x10, 0x53,
	0xCC, 0xAA, 0xC4, 0xF4, 0xA6, 0x8C, 0x32, 0xFE, 0xCB, 0x38, 0xC3, 0x0C,
	0x2F, 0xA1, 0x84, 0xE2, 0xCB, 0x70, 0xC3, 0xC8, 0x02, 0xCB, 0x2D, 0xC3,
	0x2C, 0x43, 0x4C, 0x2F, 0xC2, 0x30, 0x13, 0x4D, 0x35, 0xD5, 0x28, 0xF3,
	0x0B, 0x7C, 0xB1, 0xD8, 0x92, 0x0C, 0x36, 0xC8, 0xB0, 0xD2, 0x8A, 0x32,
	0xCE, 0xC8, 0x42, 0xCA, 0x27, 0x9E, 0xA0, 0x17, 0x0A, 0x29, 0xAA, 0x24,
	0x5B, 0x0B, 0x69, 0xF3, 0x3D, 0xEA, 0xCA, 0x2C, 0xB7, 0xF0, 0xB2, 0xCC,
	0x39, 0xFC, 0x0D, 0x50, 0x00, 0x02, 0x0D, 0x68, 0x80, 0x83, 0x0D, 0x1A,
	0x3C, 0x60, 0x51, 0x04, 0x10, 0x34, 0xB0, 0x20, 0x45, 0x16, 0x4D, 0x40,
	0x41, 0x05, 0x20, 0xF8, 0x50, 0xC4, 0x0A, 0x23, 0x94, 0xC0, 0x42, 0x0A,
	0x1E, 0x60, 0xA0, 0x01, 0x09, 0x03, 0xAE, 0x50, 0xC2, 0x0B, 0x50, 0x7C,
	0xC1, 0x45, 0x4C, 0x3F, 0xD0, 0xF0, 0x02, 0x0C, 0x34, 0xB8, 0x98, 0x04,
	0x13, 0x3C, 0xD8, 0x30, 0x83, 0x0C, 0x33, 0xD8, 0xE0, 0x13, 0x50, 0x4A,
	0xFD, 0xA4, 0x83, 0x52, 0x36, 0xD8, 0xA0, 0x03, 0x56, 0x41, 0x00, 0x51,
	0x44, 0x12, 0x45, 0xF8, 0xA0, 0x63, 0x0F, 0x3E, 0x04, 0xE1, 0x04, 0x1B,
	0x6E, 0x48, 0x71, 0x04, 0x11, 0x0A, 0x49, 0xA9, 0x04, 0x14, 0x59, 0x84,
	0xC1, 0x85, 0x14, 0x1E, 0x35, 0xF1, 0xC4, 0xCF, 0x4E, 0x3C, 0x41, 0x85,
	0x18, 0x80, 0xEC, 0xD1, 0x85, 0x14, 0x51, 0x54, 0x01, 0xC6, 0x1E, 0x8C,
	0x00, 0xC2, 0x86, 0x19, 0x6D, 0xE0, 0xA1, 0x07, 0x20, 0x8B, 0xFC, 0x91,
	0x86, 0x18, 0x6A, 0xEC, 0x41, 0xC8, 0x61, 0xA2, 0x78, 0x62, 0x48, 0x1C,
	0x84, 0x0E, 0x9A, 0xC6, 0xD8, 0x68, 0xA0, 0x91, 0x06, 0x1B, 0x71, 0xD0,
	0x41, 0x87, 0x1E, 0x8C, 0x98, 0x82, 0xCA, 0x24, 0x82, 0xCC, 0xF9, 0xC9,
	0x25, 0x83, 0x0C, 0x82, 0x49, 0x2B, 0xA2, 0x4C, 0x52, 0x0A, 0xFE, 0x29,
	0x8A, 0x18, 0xC2, 0x08, 0xA9, 0x92, 0x52, 0x92, 0xCA, 0x2C, 0xB4, 0xC0,
	0xE2, 0xCA, 0x2B, 0xA8, 0xED, 0xB2, 0x0B, 0x2E, 0xB5, 0xEC, 0x72, 0xCC,
	0x32, 0xB7, 0x68, 0xB2, 0x09, 0x2E, 0xC8, 0xFC, 0x02, 0x4B, 0x28, 0x9E,
	0x90, 0xC2, 0x4B, 0x31, 0xB7, 0x24, 0xDB, 0x4B, 0x30, 0xCD, 0x50, 0xC3,
	0xCC, 0x2E, 0xAE, 0xA8, 0x82, 0xCA, 0x2B, 0xC9, 0x58, 0x33, 0x4C, 0x2A,
	0xAA, 0x18, 0x93, 0x0C, 0xDE, 0x9E, 0x54, 0x8B, 0x9E, 0x28, 0xA6, 0xB0,
	0x82, 0xDA, 0x2C, 0xAC, 0xAC, 0xB2, 0x8A, 0xB7, 0xB2, 0x34, 0xEE, 0x4C,
	0x3A, 0xE5, 0x1A, 0xB0, 0x40, 0x05, 0x2B, 0xF8, 0x10, 0x83, 0x05, 0x0E,
	0x40, 0x10, 0x81, 0x04, 0x11, 0x4C, 0xB4, 0x60, 0x45, 0x11, 0x44, 0x4F,
	0xC1, 0x07, 0x3D, 0x00, 0x41, 0x82, 0x06, 0x1E, 0xA4, 0xA0, 0xC2, 0x07,
	0x18, 0x64, 0x10, 0xC2, 0x0C, 0x43, 0xD4, 0x00, 0x03, 0x10, 0x57, 0x64,
	0x81, 0x84, 0x0F, 0x3F, 0xE4, 0x10, 0x62, 0x0A, 0x2E, 0xD0, 0xA0, 0xC3,
	0x11, 0x46, 0xE4, 0x30, 0x43, 0x0D, 0x1A, 0xDB, 0x40, 0x43, 0xC4, 0x36,
	0xD4, 0x10, 0xF1, 0x0D, 0x1F, 0xB7, 0x68, 0xC3, 0x0E, 0x40, 0x98, 0xCA,
	0x0E, 0x7E, 0x10, 0x95, 0xA9, 0x20, 0xE5, 0x07, 0x44, 0x90, 0x82, 0x1B,
	0xE2, 0xA0, 0x05, 0x27, 0x1C, 0xA1, 0x08, 0x47, 0x48, 0x42, 0x13, 0xA6,
	0xB0, 0x85, 0x31, 0x80, 0xE1, 0x0A, 0x4F, 0x60, 0xC2, 0x12, 0x98, 0xE0,
	0x04, 0x28, 0x48, 0x61, 0x0A, 0x54, 0xD0, 0x82, 0x1C, 0x12, 0xD1, 0x07,
	0x2F, 0x50, 0x61, 0x0A, 0x56, 0xF0, 0x82, 0x1B, 0x04, 0x71, 0x08, 0x3F,
	0xD8, 0x41, 0x0F, 0x7E, 0xF0, 0xC3, 0x21, 0x1E, 0xD1, 0x07, 0x34, 0x88,
	0x61, 0x0D, 0x85, 0xA0, 0x04, 0x25, 0x36, 0x21, 0x8A, 0x4D, 0xFC, 0xE1,
	0x69, 0xFE, 0x68, 0x58, 0x83, 0xA0, 0x08, 0xA5, 0x86, 0x34, 0xA8, 0xA1,
	0x0D, 0x71, 0x90, 0x43, 0x1C, 0xEE, 0xE0, 0x88, 0x53, 0x7C, 0x82, 0x10,
	0x78, 0xA8, 0x83, 0x1F, 0x28, 0xD1, 0x89, 0x46, 0x28, 0xC2, 0x12, 0xBB,
	0xF3, 0xC4, 0xEE, 0x2C, 0x81, 0x89, 0x51, 0x78, 0xE2, 0x11, 0x8A, 0x68,
	0xC4, 0x28, 0x68, 0xA1, 0x0A, 0x4B, 0x40, 0xC2, 0x11, 0x8F, 0x98, 0x44,
	0x26, 0x3E, 0xD1, 0x89, 0x4C, 0x24, 0x66, 0x17, 0xCA, 0xA0, 0x55, 0x28,
	0x78, 0xD1, 0x0B, 0x52, 0x70, 0x02, 0x13, 0x95, 0xE0, 0x04, 0x2C, 0x80,
	0xA1, 0x0B, 0x5A, 0xCC, 0x22, 0x16, 0xB3, 0x38, 0x46, 0x34, 0x8C, 0x71,
	0x0B, 0xC3, 0xBD, 0xA2, 0x17, 0xD1, 0x88, 0x86, 0x2D, 0x4A, 0xD1, 0xBA,
	0x66, 0x61, 0x4E, 0x76, 0xA0, 0x10, 0x05, 0x29, 0x52, 0x11, 0x8B, 0xF7,
	0xC0, 0x22, 0x77, 0xBA, 0x6B, 0x05, 0x2C, 0x6A, 0xE1, 0x8B, 0x6C, 0xBC,
	0x83, 0x3F, 0x05, 0x68, 0xC0, 0x05, 0x54, 0xC0, 0x32, 0x14, 0x54, 0x40,
	0x79, 0x12, 0xB0, 0x57, 0xBC, 0x18, 0xA4, 0x3C, 0xE5, 0x55, 0x60, 0x04,
	0x25, 0x23, 0x41, 0x06, 0x24, 0xA4, 0x82, 0x10, 0x68, 0x00, 0x7B, 0x2C,
	0x18, 0x42, 0x07, 0xC3, 0x14, 0x85, 0x1B, 0xB4, 0xC0, 0x05, 0x30, 0x80,
	0xC1, 0x0A, 0x4C, 0x80, 0x82, 0x17, 0xE4, 0x40, 0x09, 0x47, 0xB0, 0x01,
	0x0C, 0x62, 0x40, 0x83, 0x8B, 0x2D, 0xB3, 0x99, 0x31, 0xA8, 0x91, 0x8B,
	0x78, 0x54, 0x83, 0x1B, 0x54, 0xCF, 0x07, 0x40, 0xEA, 0x81, 0x11, 0xA4,
	0x42, 0x15, 0xAB, 0x14, 0x81, 0x0A, 0x6D, 0x70, 0x43, 0x18, 0xAC, 0xD0,
	0x04, 0xF8, 0x29, 0x41, 0x0A, 0x5B, 0x00, 0x43, 0x17, 0xAE, 0x00, 0x85,
	0x25, 0x54, 0x69, 0x09, 0x4E, 0x98, 0x42, 0x16, 0xBA, 0xF0, 0x05, 0x33,
	0x08, 0xC2, 0x11, 0x7C, 0xFE, 0x10, 0x83, 0x16, 0xB2, 0x90, 0x4E, 0x33,
	0x8C, 0xD0, 0x11, 0x82, 0xA8, 0x43, 0x1C, 0xF2, 0xB0, 0x08, 0x46, 0xC8,
	0x81, 0x0C, 0x60, 0x58, 0x83, 0x22, 0x30, 0x71, 0x46, 0x4B, 0x58, 0x82,
	0x0F, 0x6B, 0x70, 0x49, 0x10, 0xD9, 0x20, 0x28, 0x43, 0xF9, 0x05, 0x0E,
	0x72, 0x98, 0xC3, 0x1E, 0x2E, 0x51, 0x8A, 0x48, 0xF0, 0x61, 0x0E, 0x4B,
	0x34, 0x04, 0x27, 0x46, 0xF1, 0x89, 0x4F, 0x7C, 0x6B, 0x93, 0xB3, 0xF8,
	0x96, 0x2D, 0x56, 0x31, 0x89, 0x46, 0x4C, 0xA2, 0x15, 0xAE, 0x98, 0x04,
	0x22, 0x06, 0x21, 0x88, 0xD0, 0x80, 0x2A, 0x12, 0x8F, 0x60, 0x04, 0x25,
	0x68, 0xA1, 0x0C, 0xEC, 0xF4, 0x82, 0x73, 0x9C, 0xB0, 0x44, 0x25, 0x76,
	0xC8, 0x0A, 0x5E, 0xE4, 0x82, 0x16, 0xB2, 0x70, 0x45, 0x2C, 0x8A, 0xB1,
	0x0C, 0x5C, 0xB8, 0x02, 0xA6, 0xB6, 0x58, 0xC6, 0x34, 0x84, 0xC1, 0x8A,
	0x51, 0xB4, 0xEE, 0x75, 0x5D, 0x83, 0xA4, 0x24, 0x4F, 0x87, 0x0B, 0x5E,
	0xD4, 0xA2, 0x15, 0x8F, 0xA2, 0xCD, 0xAE, 0x86, 0x21, 0x0E, 0x79, 0x08,
	0xC4, 0x3F, 0x1B, 0x98, 0x01, 0x10, 0x82, 0x10, 0x03, 0x0E, 0x4C, 0x20,
	0x7A, 0x12, 0x70, 0x08, 0x05, 0x26, 0x52, 0x11, 0x08, 0xD8, 0x75, 0x7A,
	0x33, 0x50, 0x42, 0x10, 0x4A, 0xC0, 0x01, 0x0F, 0x9C, 0xC0, 0x60, 0x1E,
	0xE8, 0xEB, 0x09, 0x72, 0x40, 0x85, 0x2F, 0x68, 0x41, 0x0A, 0x4B, 0xB0,
	0x41, 0x0A, 0x4E, 0xC0, 0x02, 0x18, 0xB8, 0xE0, 0x04, 0x26, 0x58, 0xC1,
	0x0D, 0x3C, 0x62, 0x83, 0x16, 0xB0, 0xE0, 0x97, 0x2E, 0x78, 0x41, 0x0C,
	0x9C, 0xF9, 0x4C, 0x1C, 0x80, 0x0C, 0x07, 0xE8, 0xDB, 0xC1, 0x4F, 0x7C,
	0x60, 0x04, 0x23, 0xFC, 0x60, 0x65, 0xFA, 0xAA, 0xC2, 0x1A, 0xC6, 0x70,
	0x05, 0x2C, 0xC4, 0xE4, 0x08, 0x4B, 0xA0, 0xFE, 0x42, 0x16, 0xAE, 0x30,
	0x05, 0xB0, 0x28, 0x81, 0x4A, 0xF0, 0xB4, 0xC2, 0x17, 0xC8, 0xA0, 0x06,
	0x3C, 0x28, 0x82, 0x11, 0x79, 0x28, 0x43, 0x18, 0x4A, 0x24, 0x06, 0x30,
	0xA0, 0x81, 0x10, 0x8C, 0xB8, 0xC3, 0xA0, 0xEE, 0xD0, 0x88, 0x43, 0xAC,
	0xE1, 0x0B, 0x5F, 0x58, 0x03, 0x22, 0x1E, 0x61, 0x07, 0x39, 0xAC, 0xC9,
	0x10, 0x6F, 0x28, 0x03, 0x19, 0xCC, 0x90, 0x06, 0x21, 0x52, 0x94, 0xA2,
	0x6D, 0x78, 0x43, 0xDA, 0xFC, 0xB0, 0x89, 0x50, 0x18, 0x42, 0x0F, 0x20,
	0xA5, 0x83, 0x1F, 0x1E, 0xC1, 0xC8, 0x55, 0x24, 0xEB, 0x3D, 0xB4, 0xC0,
	0xC5, 0x2E, 0x74, 0x01, 0x0B, 0x4F, 0x68, 0xC2, 0x14, 0xB4, 0x30, 0x05,
	0x23, 0x68, 0x1A, 0x88, 0x9A, 0x16, 0x22, 0x11, 0x8F, 0xC8, 0xE9, 0x24,
	0x60, 0xC1, 0x1D, 0x64, 0x04, 0x03, 0x18, 0xB2, 0xF0, 0x44, 0x26, 0x16,
	0x1C, 0x0A, 0x5B, 0x08, 0x43, 0x17, 0xB1, 0x81, 0x85, 0x2C, 0xB6, 0x53,
	0x0B, 0x53, 0x88, 0x62, 0x14, 0xAE, 0x58, 0x46, 0x33, 0x64, 0x71, 0x8A,
	0x51, 0xB0, 0x22, 0x19, 0xD1, 0x9A, 0x56, 0xB5, 0x40, 0x11, 0x49, 0x46,
	0xBE, 0xE2, 0x16, 0xBD, 0xB8, 0xC5, 0x6C, 0x5A, 0x01, 0x53, 0x59, 0xEC,
	0x02, 0x1A, 0xEA, 0xA0, 0xC7, 0x59, 0x1D, 0xC0, 0x02, 0x22, 0x20, 0x01,
	0x08, 0x2C, 0xE0, 0x40, 0x05, 0x96, 0x47, 0x01, 0x81, 0x5D, 0x00, 0x02,
	0xF4, 0xB2, 0xAB, 0x04, 0x34, 0xD0, 0x82, 0x24, 0x44, 0xA1, 0x08, 0x22,
	0x89, 0xAC, 0x0B, 0x50, 0x10, 0x82, 0x0F, 0x84, 0x20, 0x05, 0x39, 0x90,
	0x82, 0x61, 0xC1, 0xB2, 0x03, 0x17, 0xAC, 0xC0, 0x05, 0x32, 0x88, 0xC1,
	0x0A, 0x54, 0xE0, 0x82, 0x1C, 0x4C, 0x61, 0x0A, 0x39, 0x78, 0x81, 0x0B,
	0xC6, 0x0C, 0x83, 0x15, 0xD9, 0x2F, 0x9A, 0x2B, 0xC2, 0xC1, 0xFE, 0x0E,
	0x78, 0x04, 0x5A, 0x20, 0x24, 0x85, 0x07, 0x43, 0x48, 0xC2, 0x11, 0x4E,
	0x9B, 0x24, 0x02, 0x76, 0xA1, 0x0D, 0x5E, 0xC9, 0x02, 0x16, 0xA0, 0x60,
	0x25, 0x2A, 0x60, 0xC1, 0x0A, 0x27, 0x84, 0x42, 0x13, 0x96, 0xB0, 0x41,
	0x9C, 0x81, 0xA1, 0x30, 0x7A, 0x28, 0x84, 0x22, 0xFA, 0xB0, 0x86, 0x33,
	0x9C, 0xC1, 0x0C, 0x61, 0xF0, 0x42, 0x19, 0x04, 0x81, 0x88, 0x36, 0x94,
	0x01, 0x0D, 0x79, 0x78, 0x44, 0x21, 0xD4, 0x00, 0xDD, 0x35, 0x24, 0x02,
	0x12, 0x76, 0x80, 0xC3, 0x1D, 0x22, 0x21, 0x89, 0x3B, 0xA8, 0xE1, 0x4D,
	0x6A, 0x60, 0x43, 0x38, 0x21, 0x13, 0xCE, 0x37, 0x28, 0x6A, 0x10, 0xA1,
	0x18, 0xC5, 0x22, 0x00, 0xA1, 0x87, 0x3C, 0xEC, 0x61, 0x10, 0x91, 0x08,
	0x45, 0x29, 0x4C, 0x01, 0x9B, 0x5C, 0xD8, 0x62, 0x57, 0xBD, 0xD8, 0x85,
	0x8A, 0x57, 0x11, 0xDF, 0x53, 0x48, 0xA2, 0x11, 0xC8, 0x46, 0x63, 0x1A,
	0x31, 0x81, 0x09, 0x4B, 0x6C, 0x82, 0x16, 0xC8, 0x68, 0x06, 0xE7, 0x6C,
	0x31, 0x0B, 0x53, 0x90, 0x62, 0x14, 0xA5, 0x68, 0x85, 0x2F, 0x0C, 0x8C,
	0x8B, 0x5B, 0xE0, 0x22, 0x17, 0xBF, 0x50, 0x46, 0x2F, 0x4A, 0xD1, 0x89,
	0x4F, 0xB0, 0x22, 0x56, 0xB3, 0x40, 0x45, 0x29, 0x5C, 0xC1, 0x0C, 0x6C,
	0x04, 0x03, 0x15, 0xE7, 0x49, 0x8F, 0x7A, 0x4E, 0xE1, 0x8A, 0x5A, 0xF0,
	0xE2, 0x17, 0xB6, 0x78, 0xEA, 0x2B, 0x5E, 0x11, 0x0B, 0x5A, 0xFC, 0x62,
	0x1B, 0xEF, 0xA8, 0xC7, 0x59, 0x1F, 0x00, 0x03, 0xD8, 0x1E, 0xC1, 0x07,
	0x2E, 0xD8, 0xC0, 0xBD, 0x2E, 0xC0, 0xA1, 0x0C, 0x44, 0xA0, 0x01, 0x0D,
	0x52, 0xDE, 0x04, 0x3E, 0xC0, 0x83, 0x29, 0x5C, 0x41, 0x0A, 0x4A, 0x10,
	0x02, 0xCB, 0x72, 0x50, 0x4B, 0x0F, 0x88, 0xC0, 0x05, 0x43, 0x88, 0x02,
	0x3D, 0xE8, 0xAF, 0xD0, 0x04, 0x1F, 0xD4, 0x40, 0x7F, 0x35, 0x98, 0x41,
	0x8D, 0x6E, 0x20, 0x84, 0x7D, 0xA6, 0x28, 0x64, 0x1A, 0x13, 0xCA, 0x8F,
	0xEC, 0xC7, 0x22, 0x1D, 0x14, 0x05, 0x47, 0x3E, 0x18, 0xC2, 0x10, 0x82,
	0x30, 0x04, 0x25, 0x94, 0xF3, 0x07, 0x07, 0x0C, 0x42, 0x12, 0xBE, 0xC0,
	0x86, 0x2F, 0x6C, 0xC1, 0xE8, 0x88, 0x6D, 0x42, 0x15, 0xB8, 0x10, 0x86,
	0x31, 0x84, 0x61, 0x0B, 0x53, 0x70, 0x82, 0xCF, 0xA6, 0xA0, 0x05, 0x31,
	0xA4, 0x41, 0x51, 0x79, 0x38, 0xC4, 0x21, 0xF2, 0x60, 0xE9, 0xE2, 0x7E,
	0xE1, 0x0C, 0x84, 0x58, 0x04, 0x1D, 0xCE, 0x06, 0x88, 0x47, 0x0C, 0xA2,
	0x0D, 0x64, 0x18, 0x43, 0x1B, 0x18, 0xB1, 0x89, 0x48, 0x14, 0xA2, 0x10,
	0x97, 0xE0, 0x44, 0x21, 0xE2, 0xA0, 0x6A, 0xC9, 0xC0, 0xE1, 0xEE, 0x6F,
	0x88, 0x4C, 0x1C, 0xEA, 0xD0, 0x07, 0x4A, 0xA8, 0x02, 0x6F, 0x95, 0x58,
	0xC4, 0xA5, 0x32, 0x81, 0x8A, 0x56, 0x9C, 0x42, 0x31, 0xB2, 0x38, 0xEA,
	0x2A, 0x38, 0xF9, 0x8B, 0x5E, 0xD8, 0xE2, 0x15, 0x2E, 0xC6, 0x05, 0x2C,
	0x58, 0xEC, 0x8A, 0xC3, 0x49, 0xD8, 0x16, 0xB7, 0xA8, 0x05, 0x2E, 0x86,
	0xC1, 0x8C, 0x67, 0x28, 0x63, 0x18, 0xC3, 0x20, 0xC6, 0x2F, 0x32, 0xCF,
	0x0B, 0x5E, 0xDC, 0x46, 0x18, 0xBF, 0x38, 0x06, 0x33, 0x92, 0x71, 0x0C,
	0x67, 0x10, 0x23, 0x15, 0x9F, 0x08, 0xC5, 0x2B, 0x9C, 0x71, 0x8D, 0x61,
	0x94, 0xE6, 0xDC, 0xDD, 0x58, 0xC6, 0x2A, 0xE2, 0xAD, 0x1E, 0xAB, 0xFA,
	0x1B, 0x19, 0xC0, 0xA8, 0x45, 0xE5, 0x5F, 0x01, 0x0B, 0x70, 0x0D, 0x23,
	0x1C, 0xF1, 0xA8, 0x47, 0x40, 0x00 };
	int i, r, g, b, colour_change;

	/* GIF header */
	printf("GIF");                /* signature */
	printf("87a");                /* version */
	/* logical screen descriptor */
	putchar(0); putchar(1);       /* width */
	putchar(8); putchar(0);       /* height */
	putchar(0xF7);                /* 256 colours with table to follow */
	putchar(0);                   /* background colour */
	putchar(0);                   /* reserved (aspect ratio in 89a) */
	/* global colour table - do'n't mess the colours up, just the colour table;
	like the old trick with 256-colour games where they do animation with
	colour cycling */
	r = 0xF0, g = 0x00, b = 0x32; /* aiming for 0x50 0xA0 0xC0 */
	if(parm < 40) {
		colour_change = (40 - parm) << 1;
		r -= colour_change;
		g += colour_change;
		b += colour_change;
	}
	for(i = 0; i <= 0xFF; i++) {
		if(i >= parm - 40 && i < parm + 40) {
			r -= 2; g += 2; b += 2;
		}
		putchar(r); putchar(g); putchar(b);
	}
	/* image descriptor */
	putchar(',');                 /* image separator */
	putchar(0); putchar(0);       /* image left position */
	putchar(0); putchar(0);       /* image top position */
	putchar(0); putchar(1);       /* image width */
	putchar(8); putchar(0);       /* image height */
	putchar(0);                   /* packed flags - use global table */
	/* image data block, *ptr, size, ntimes, stream */
	if(fwrite(image_data, sizeof(char), sizeof(image_data), stdout) != sizeof(image_data))
		{ perror("stdout"); }
	putchar(0);                   /* terminating empty sub-block */
	/* GIF trailer */
	putchar(';');                 /* trailer */
}
